var batchPlay = require("photoshop").action.batchPlay;
const app = require('photoshop').app;
const UXP = require("uxp").app


//	saving an open document
const zz = async () => {
	var doc = app.activeDocument;
	const docPath = app.activeDocument.path;
	var fin = docPath.length - docPath.lastIndexOf("\\") - 1 - 4;
	var debut = docPath.lastIndexOf("\\")+1
	const docName = docPath.substr(debut, fin);


const docPathShort = docPath.substr(0, docPath.lastIndexOf("\\"));
var saveFolder = await require("uxp").storage.localFileSystem.getFolder(docPath);
var saveFile = await saveFolder.createFile(docName+".tif");
var saveFileToken = await require("uxp").storage.localFileSystem.createSessionToken(saveFile);
await saveTIF(saveFileToken);

async function saveTIF(fileToken){
    
const batchPlay = require("photoshop").action.batchPlay;

await batchPlay(
[
   {
      "_obj": "save",
      "as": {
         "_obj": "TIFF",
         "byteOrder": {
            "_enum": "platform",
            "_value": "IBMPC"
         },
         "LZWCompression": true,
         "saveTransparency": true,
         "layerCompression": {
            "_enum": "encoding",
            "_value": "RLE"
         }
      },
      "in": {
         "_path": fileToken,
         "_kind": "local"
      },
      "saveStage": {
         "_enum": "saveStageType",
         "_value": "saveBegin"
      },
      "_isCommand": false,
      "_options": {
         "dialogOptions": "dontDisplay"
      }
   }
],{
   "synchronousExecution": false,
   "modalBehavior": "fail"
});
      
}
}

//	Create and save a persistent token then open file
const xx = async () => {

console.log("UNCLE");
const fs = require('uxp').storage.localFileSystem;
var doc = app.activeDocument;
const docPath = app.activeDocument.path;
const docPathShort = docPath.substr(0,docPath.lastIndexOf("\\"));

let entry = await fs.getFileForOpening();
let token = fs.createPersistentToken(entry);
localStorage.setItem("persistent-file", token);
 app.open(entry);
console.log("token: "+token);

}

//	 Open the file using the token
const yy = async () => {
const fs = require('uxp').storage.localFileSystem;
let entry, contents, tries = 1, success = false;
while (tries > 0) {
    try {
        entry = await fs.getEntryForPersistentToken(localStorage.getItem("persistent-file"));
        contents = await entry.read();
        tries = 0;
        success = true;
    } catch (err) {
        entry = await fs.getFileForOpening();
        localStorage.setItem("persistent-token", await fs.createPersistentToken(entry));
        tries--;
    }
}
if (!success) {
    // fail gracefully somehow
}
 
 app.open(entry);
 

//console.log("Name: "+entry.name);
//console.log("Native Path: "+entry.nativePath);
//console.log("Contents: "+contents);

}


//	index.js:146 Uncaught TypeError: Cannot read property 'addEventListener' of null
const hand = async () => {
	
return await batchPlay(
[
   {
      "_obj": "select",
      "_target": [
         {
            "_ref": "handTool"
         }
      ],
      "dontRecord": true,
      "forceNotify": true,
      "_isCommand": false,
      "_options": {
         "dialogOptions": "dontDisplay"
      }
   }
],{
   "synchronousExecution": false,
   "modalBehavior": "fail"
});
	
}




async function showAlert(message) {
  const app = require('photoshop').app;
  await app.showAlert(message);
}

document.getElementById("btnZero").addEventListener("click", function () {zz()});
document.getElementById("btnOne").addEventListener("click", function () {yy()});
document.getElementById("btnTwo").addEventListener("click", function () {xx()});
document.getElementById("btnFour").addEventListener("click", function () {hand()});
document.getElementById("btnThree").addEventListener("click", function () {location.reload()});